'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Loader = require('./Loader');

var _Loader2 = _interopRequireDefault(_Loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockUi = function (_Component) {
  _inherits(BlockUi, _Component);

  function BlockUi() {
    _classCallCheck(this, BlockUi);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  BlockUi.prototype.render = function render() {
    var _props = this.props;
    var Tag = _props.tag;
    var blocking = _props.blocking;
    var className = _props.className;
    var children = _props.children;
    var renderChildren = _props.renderChildren;

    var attributes = _objectWithoutProperties(_props, ['tag', 'blocking', 'className', 'children', 'renderChildren']);

    if (blocking) {
      var classes = (0, _classnames2.default)('av-block-ui', className);

      return _react2.default.createElement(
        Tag,
        _extends({}, attributes, { className: classes }),
        renderChildren && children,
        _react2.default.createElement(
          'div',
          { className: 'av-block-ui-container' },
          _react2.default.createElement('div', { className: 'av-block-ui-overlay' }),
          _react2.default.createElement(
            'div',
            { className: 'av-block-ui-message-container' },
            _react2.default.createElement(
              'div',
              { className: 'av-block-ui-message' },
              _react2.default.createElement(_Loader2.default, null)
            )
          )
        )
      );
    }

    return _react2.default.createElement(
      Tag,
      _extends({}, attributes, { className: className }),
      children
    );
  };

  return BlockUi;
}(_react.Component);

BlockUi.propTypes = {
  blocking: _react.PropTypes.bool,
  children: _react.PropTypes.node,
  renderChildren: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  tag: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.func])
};
BlockUi.defaultProps = {
  tag: 'div',
  renderChildren: true
};
exports.default = BlockUi;