'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bezierEasing = require('bezier-easing');

var _bezierEasing2 = _interopRequireDefault(_bezierEasing);

var _animate = require('./animate');

var _animate2 = _interopRequireDefault(_animate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var easeIn = (0, _bezierEasing2.default)(0, 0.3, 0.45, 1);

var enter = function enter(el) {
  var render = function render(percent) {
    el.style.opacity = percent;
    el.style.transform = 'translateX(' + (20 - 20 * percent) + 'px) translateZ(0)';
  };

  return (0, _animate2.default)(render, 750, easeIn);
};
var leave = function leave(bullets) {
  var render = function render(percent) {
    bullets.forEach(function (el) {
      el.style.opacity = 1 - percent;
    });
  };

  return (0, _animate2.default)(render, 500, easeIn);
};

var Loader = function (_Component) {
  _inherits(Loader, _Component);

  function Loader() {
    var _temp, _this, _ret;

    _classCallCheck(this, Loader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.bullets = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  Loader.prototype.componentDidMount = function componentDidMount() {
    this.addBullet(0);
  };

  Loader.prototype.removeBullets = function removeBullets() {
    var _this2 = this;

    this.clearTimeout();
    this.timeout = setTimeout(function () {
      _this2.cancelLeave = leave(_this2.bullets);
      _this2.addBullet(0, 950);
    }, 1800);
  };

  Loader.prototype.addBullet = function addBullet(bullet) {
    var _this3 = this;

    var delay = arguments.length <= 1 || arguments[1] === undefined ? 250 : arguments[1];

    this.clearTimeout();
    this.timeout = setTimeout(function () {
      _this3.cancelEnter = enter(_this3.bullets[bullet]);
      if (bullet < 2) {
        _this3.addBullet(++bullet);
      } else {
        _this3.removeBullets();
      }
    }, delay);
  };

  Loader.prototype.clearTimeout = function (_clearTimeout) {
    function clearTimeout() {
      return _clearTimeout.apply(this, arguments);
    }

    clearTimeout.toString = function () {
      return _clearTimeout.toString();
    };

    return clearTimeout;
  }(function () {
    this.timeout && clearTimeout(this.timeout);
  });

  Loader.prototype.componentWillUnmount = function componentWillUnmount() {
    this.clearTimeout();
    this.cancelEnter && this.cancelEnter();
    this.cancelLeave && this.cancelLeave();
  };

  Loader.prototype.render = function render() {
    var _this4 = this;

    return _react2.default.createElement(
      'div',
      { className: 'av-loading-indicator' },
      _react2.default.createElement(
        'span',
        { ref: function ref(c) {
            return _this4.bullets[0] = c;
          }, className: 'av-loading-bullet' },
        '•'
      ),
      ' ',
      _react2.default.createElement(
        'span',
        { ref: function ref(c) {
            return _this4.bullets[1] = c;
          }, className: 'av-loading-bullet' },
        '•'
      ),
      ' ',
      _react2.default.createElement(
        'span',
        { ref: function ref(c) {
            return _this4.bullets[2] = c;
          }, className: 'av-loading-bullet' },
        '•'
      )
    );
  };

  return Loader;
}(_react.Component);

exports.default = Loader;